/********************************************************************
 * Copyright (C) 2005 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of BsC (Beesoft Commander).
 *
 * BsC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BsC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BsC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *******************************************************************/
#ifndef INCLUDED_CONSOLE_H
#define INCLUDED_CONSOLE_H

/*------- forward declarations:
-------------------------------------------------------------------*/
class QTextEdit;
class QLineEdit;
class QProcess;

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QFRAME_H
#include <qframe.h>
#define INCLUDED_QFRAME_H
#endif // INCLUDED_QFRAME_H

/*------- class declaration:
-------------------------------------------------------------------*/
class Console : public QFrame
{
	Q_OBJECT
public:
	Console( QWidget* const in_parent );
	~Console();
private:
	Console( const Console& );
	Console& operator=( const Console& );

// ******* MEMBERS *******
private:
	static const int  OVER_STRETCH;
	static const QRgb BROWSER_DEFAULT_TEXT_COLOR;
	static const QRgb BROWSER_DEFAULT_BACKGROUND_COLOR;
	static const QRgb CMD_DEFAULT_TEXT_COLOR;
	static const QRgb CMD_DEFAULT_BACKGROUND_COLOR;
	
	QTextEdit* const d_browser;
	QLineEdit* const d_cmd;
	QColor           d_browser_fg_color;
	QColor           d_browser_bg_color;
	QColor           d_cmd_fg_color;
	QColor           d_cmd_bg_color;
	QProcess*        d_process;
	bool             d_ready;

// ******* METHODS *******
private:
	void showEvent( QShowEvent* e );
private slots:
	void return_pressed();
	void read_from_stdout();
	void read_from_stderr();
	void process_exited();
};

#endif // INCLUDED_CONSOLE_H
