/********************************************************************
 * Copyright (C) 2005 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of BsC (Beesoft Commander).
 *
 * BsC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BsC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BsC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *******************************************************************/
#ifndef INCLUDED_RIGHTVIEW_H
#define INCLUDED_RIGHTVIEW_H

/*------- include files:
-------------------------------------------------------------------*/
#ifndef INCLUDED_QFRAME_H
#include <qframe.h>
#define INCLUDED_QFRAME_H
#endif // INCLUDED_QFRAME_H

/*------- forward declarations:
-------------------------------------------------------------------*/
class ViewWindow;
class Workspace;
class QToolBar;
class QWidgetStack;

/*------- class declaration:
-------------------------------------------------------------------*/
class RightView : QFrame
{
	Q_OBJECT

// ******* CONSTRUCTION *******
public:
	RightView( QWidget* const in_parent, Workspace* const in_workspace );
	~RightView();
private:
	RightView( const RightView& );
	RightView& operator=( const RightView& );

// ******* MEMBERS *******
private:
	static const QString ArgPrefix;
	static const QString ConfigGroupName;
	ViewWindow* const d_view;
	
// ******* METHODS *******
public:
	bool has_focus() const;
signals:
	void F5();
	void F9();
	void update_lang();
};

#endif // INCLUDED_RIGHTVIEW_H
